
// SPDX-License-Identifier: BUSL-1.1
pragma solidity 0.8.21;

import "./BlastPointsReceiver.sol";
import "@openzeppelin/contracts-upgradeable/proxy/utils/Initializable.sol";

abstract contract BlastPointsReceiverUpgradeable is Initializable {
    error InvalidPointsOperator();

    function __BlastPointsReceiverUpgradeable_init(IBlastPoints _blastPoints, address _pointsOperator) internal onlyInitializing {
        __BlastPointsReceiverUpgradeable_init_unchained(_blastPoints, _pointsOperator);
    }

    function __BlastPointsReceiverUpgradeable_init_unchained(IBlastPoints _blastPoints, address _pointsOperator) internal onlyInitializing {
        if(address(_blastPoints) != address(0)){
            if(_pointsOperator == address(0)) revert InvalidPointsOperator();
		    _blastPoints.configurePointsOperator(_pointsOperator);
        } else if(_pointsOperator != address(0)) revert InvalidPointsOperator();
    }
}
